<template>
  <div v-if="quote !== null">
    Tsitaadi muutmine...
    <br />
    <form @submit="saveQuote">
      Tsitaat <br />
      <textarea cols="60" rows="10" v-model="quote.text"></textarea>
      <br />
      Kategooria <br />
      <input type="text" v-model="quote.category" />
      <br />
      <button type="submit">Salvesta</button>
    </form>
  </div>
</template>

<script>
export default {
  name: "QuoteUpdateForm",
  data() {
    return {
      quote: null,
    };
  },
  created() {
    if (this.$route.params.quoteId !== undefined) {
      // Siin sees me teame, et tegemist on olemasoleva tsitaadi muutmisega.
      this.fetchQuote();
    } else {
      // Siin sees me teame, et tegemist on uue tsitaadi lisamisega.
      this.prepareQuote();
    }
  },
  methods: {
    prepareQuote() {
      this.quote = { text: "", category: "" };
    },
    async fetchQuote() {
      const quoteId = this.$route.params.quoteId;
      console.log(quoteId);
      const response = await fetch(
        // "https://frogaccelerator.com:8090/api/quote/" + quoteId
        "http://localhost:8090/quotes/quote/" + quoteId
      );
      this.quote = await response.json();
      this.quoteAuthor =
        this.quote.author !== null ? this.quote.author.name : "";
    },
    async saveQuote(event) {
      event.preventDefault();
      // Tekitame request objekti
      const quoteRequest = {
        text: this.quote.text,
        category: this.quote.category,
      };

      if (this.$route.params.quoteId !== undefined) {
        // Muudame olemasolevat tsitaati
        await fetch(
          // "https://frogaccelerator.com:8090/api/quote/" + this.quote.id,
          "http://localhost:8090/quotes/quote/" + this.quote.id,
          {
            method: "PUT",
            headers: {
              "Content-Type": "application/json",
            },
            body: JSON.stringify(quoteRequest),
          }
        );
      } else {
        // Lisame uue tsitaadi
        await fetch(
          "http://localhost:8090/quotes/quote",
          {
            method: "POST",
            headers: {
              "Content-Type": "application/json",
            },
            body: JSON.stringify(quoteRequest),
          }
        );
      }

      this.$router.push("/quotes-list");
    },
  },
};
</script>